CADxp: [Résolu] Sélectionner des textes avec un bouton - CADxp

Aller au contenu

Page 1 sur 1
  • Vous ne pouvez pas commencer un sujet
  • Vous ne pouvez pas répondre à ce sujet

[Résolu] Sélectionner des textes avec un bouton

#1 L'utilisateur est hors-ligne   Dubloc 

  • ceinture verte
  • Groupe : Membres
  • Messages : 66
  • Inscrit(e) : 13-avril 06
  • LocationAlsace - France

Posté 18 avril 2019 - 10:55

Bonjour

Je coince sur une petite macro de bouton, et j'aurais besoin d'un peu d'aide...

Si je tape au clavier :
(ssget "X" '((0 . "TEXT,MTEXT")))
select
p


tous les TEXT et MTEXT sont sélectionnés. Là ca marche comme je veux, c'est parfait...

Mais lorsque je mets ceci dans un bouton : (ssget "X" '((0 . "TEXT,MTEXT")));select;p;;
ca ne marche plus. Autocad me dit "207 trouvé(s)" mais ils ne sont pas sélectionnés, je dois refaire select p au clavier... pourquoi ?

Merci d'avance ;o)
0

#2 L'utilisateur est hors-ligne   didier 

  • ceinture rouge et blanche 8em dan
  • Groupe : Moderateurs
  • Messages : 8386
  • Inscrit(e) : 18-décembre 02
  • LocationPlanète : Terre

Posté 18 avril 2019 - 11:14

Coucou

Et avec un ssgetfirst quelque part dans la macro ça marche mieux ?
Pardon mais je ne suis pas un spécialiste de la macro...
En lisp c'est que je ferais

Éternel débutant ...
Programmer AutoCAD
0

#3 L'utilisateur est hors-ligne   rebcao 

  • ceinture rouge et blanche 8em dan
  • Groupe : Membres
  • Messages : 7138
  • Inscrit(e) : 25-août 04
  • LocationSELESTAT

Posté 18 avril 2019 - 15:52

Bonjour,

Jette un oeil à la variable système PICKSTYLE !

Et au début de ta MACRO commence avec ^C^C

Christian
Formateur, Consultant Expert AutoCAD, REVIT MEP, INVENTOR, télécharger des Supports de Cours AutoCAD, des Outils AutoCAD...
cad123 @ wanadoo.fr (enlever les espaces de part et d'autre de @)
0

#4 L'utilisateur est hors-ligne   Dubloc 

  • ceinture verte
  • Groupe : Membres
  • Messages : 66
  • Inscrit(e) : 13-avril 06
  • LocationAlsace - France

Posté 22 avril 2019 - 16:20

@didier :
Après consultation de l'aide concernant ssgetfirst, que je ne connaissait pas, j'avoue ne pas en comprendre l'utilisation... mais quoi qu'il en soit quand je la met "quelque part" dans la macro ca ne change rien !

@rebcao :
Quelle que soit la valeur de pickfirst pickstyle même résultat... Quant à ^C^C au début de la macro, je l'aurais bien-sûr ajouté dans la version définitive de la macro, si elle marchait ;o)


Ce qui est curieux, c'est que si dans la macro je met : (ssget "X" '((0 . "TEXT,MTEXT")));select;
et que je complète au clavier avec P puis [ENTREE] ca marche bien... c'est la commande select qui ne veut vraisemblablement pas se laisser mettre en macro...
Bizarre ce comportement, non ?

Merci tout de même à vous deux pour votre sollicitude !

Ce message a été modifié par Dubloc - 23 avril 2019 - 15:47 .

0

#5 L'utilisateur est hors-ligne   rebcao 

  • ceinture rouge et blanche 8em dan
  • Groupe : Membres
  • Messages : 7138
  • Inscrit(e) : 25-août 04
  • LocationSELESTAT

Posté 22 avril 2019 - 16:51

Bonjour,

PICKSTYLE ! pas PICKFIRST ?!

Christian
Formateur, Consultant Expert AutoCAD, REVIT MEP, INVENTOR, télécharger des Supports de Cours AutoCAD, des Outils AutoCAD...
cad123 @ wanadoo.fr (enlever les espaces de part et d'autre de @)
0

#6 L'utilisateur est hors-ligne   (gile) 

  • ceinture rouge et blanche 8em dan
  • Groupe : Moderateurs
  • Messages : 11277
  • Inscrit(e) : 02-septembre 05

Posté 22 avril 2019 - 17:03

Salut,

On parle bien de LISP ici.
On peut, bien sûr utiliser des expressions LISP dans les macros de commande et dans les scripts comme on peut les entrer directement en ligne de commande.
Ici, l'expression LISP serait:
(sssetfirst nil (ssget "X" '((0 . "TEXT,MTEXT"))))
qu'on peut mettre dans une macro de commande en la faisant précéder par ^C^C pour garantir l'annulation de toute commande en cours.

PS: la fonction sssetfirst est documentée en français sur da-code (le site de didier) et dans Introduction à AutoLISP (section 16.3)
Gilles Chanteau - gileCAD -
Développements sur mesure pour AutoCAD
Image IPB
0

#7 L'utilisateur est hors-ligne   Dubloc 

  • ceinture verte
  • Groupe : Membres
  • Messages : 66
  • Inscrit(e) : 13-avril 06
  • LocationAlsace - France

Posté 23 avril 2019 - 15:50

En effet rebcao, c'est bien pickstyle que j'ai testé, c'est à la rédaction de ma réponse que j'ai confondu !
0

#8 L'utilisateur est hors-ligne   Dubloc 

  • ceinture verte
  • Groupe : Membres
  • Messages : 66
  • Inscrit(e) : 13-avril 06
  • LocationAlsace - France

Posté 23 avril 2019 - 16:08

Bonjour,

Merci (gile) pour ton aide, c'est parfait avec ton code !
Ce qui est déroutant (pour moi) c'est qu'une même syntaxe au clavier ou dans un bouton ne parvienne pas au même résultat, mon niveau en LISP étant trop lacunaire je n'aurais sans doutes jamais trouvé tout seul.

:)
0

Partager ce sujet :


Page 1 sur 1
  • Vous ne pouvez pas commencer un sujet
  • Vous ne pouvez pas répondre à ce sujet

1 utilisateur(s) en train de lire ce sujet
0 membre(s), 1 invité(s), 0 utilisateur(s) anonyme(s)